package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchRequest;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.scheduling.management.SchCollectorVersionLog;
import com.docus.server.infrastructure.mapper.SchCollectorVersionLogMapper;
import com.docus.server.infrastructure.dao.ISchCollectorVersionLogDao;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;
import java.util.Date;
import java.util.List;
/**
 *
 * 采集器版本更新日志管理 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-07-14
 */
@Repository
public class SchCollectorVersionLogDaoImpl extends BaseDaoImpl<SchCollectorVersionLogMapper, SchCollectorVersionLog> implements ISchCollectorVersionLogDao {

    /**
    *按主键查询
    * @param id 主键Id
    * @return 实体
    */
    @Override
    public SchCollectorVersionLog findById(String id) {
        return super.findById(id);
    }

    /**
    * 新增
    * @param schCollectorVersionLog 编辑参数
    * @return 成功或失败
    */
    @Override
    public boolean add(SchCollectorVersionLog  schCollectorVersionLog) {
        return super.save(schCollectorVersionLog);
    }

    /**
    * 编辑
    * @param schCollectorVersionLog 编辑参数
    * @return 成功或失败
    */
    @Override
    public boolean edit(SchCollectorVersionLog  schCollectorVersionLog) {
        return super.updateById(schCollectorVersionLog);
    }

    /**
    * 批量删除
    * @param ids 主键ids
    * @return 成功或失败
    */
    @Override
    public int delete(List<String> ids) {
        return super.deleteByIds(ids);
    }

    /**
    * 关键字搜素
    * @param searchRequest 搜索参数
    * @return 分页列表
    */
    @Override
    public PageResult<SchCollectorVersionLog> search(SearchRequest searchRequest) {
        //分页
        PageHelper.startPage(searchRequest.getPageNum(), searchRequest.getPageSize());
        LambdaQueryWrapper<SchCollectorVersionLog> query = Wrappers.lambdaQuery() ;
        //时间范围，默认按createTime
        if (searchRequest.getBeginTime() != null) {
            query.ge(SchCollectorVersionLog::getCreateTime, searchRequest.getBeginTime());
        }
        if (searchRequest. getEndTime() != null) {
            Date endTime = searchRequest.getEndTime();
            query.le(SchCollectorVersionLog::getCreateTime, endTime);
        }
        //关键字比较，多个列or
        //if (!StringUtils.isEmpty(searchRequest.getKeyword())) {
        //单个列用like
        //query. like(SchCollectorVersionLog::getxxx, searchRequest. getKeyword());
        //多个列用like
        //query. and(sub -> sub.like(SchCollectorVersionLog::getxx1, searchRequest. getKeyword())
        // оr(). like(SchCollectorVersionLog::getXX2, searchRequest. getKeyword()))
        //);
        //}
        //默认createTime倒序排序
        query.orderByDesc(SchCollectorVersionLog::getCreateTime);
        List<SchCollectorVersionLog> list = super.find(query);
        return new PageResult<>(list);
    }

}
